ompi/attribute/attribute_predefined.c File Reference.TH "ompi/attribute/attribute_predefined.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/attribute/attribute_predefined.c \- Setup the predefined attributes in MPI. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'mpi.h'\fP
.br
\fC#include 'attribute/attribute.h'\fP
.br
\fC#include 'ompi/errhandler/errclass.h'\fP
.br
\fC#include 'ompi/communicator/communicator.h'\fP
.br
\fC#include 'orte/util/proc_info.h'\fP
.br
\fC#include 'ompi/mca/pml/pml.h'\fP
.br
\fC#include 'orte/mca/ns/ns.h'\fP
.br
\fC#include 'orte/mca/gpr/gpr.h'\fP
.br
\fC#include 'orte/mca/errmgr/errmgr.h'\fP
.br
\fC#include 'orte/mca/schema/schema.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "static int \fBcreate_comm\fP (int target_keyval, bool want_inherit)"
.br
.ti -1c
.RI "static int \fBset_f\fP (int keyval, MPI_Fint value)"
.br
.ti -1c
.RI "int \fBompi_attr_create_predefined\fP (void)"
.br
.ti -1c
.RI "void \fBompi_attr_create_predefined_callback\fP (\fBorte_gpr_notify_data_t\fP *data, void *cbdata)"
.br
.in -1c
.SH "Detailed Description"
.PP 
Setup the predefined attributes in MPI. 

A number of pre-defined attributes are created here, most of which are exactly what one would expect, but there are a few exceptions -- so they're documented here.
.PP
Predefined attributes are integer-valued or address-valued (per MPI-2; see section 4.12.7, keeping in mind that Example 4.13 is totally wrong -- see src/attribute/attribute.h for a lengthy explanation of this).
.PP
The only address-valued attribute is MPI_WIN_BASE. We treat it as if it were set from C. All other attributes are integer-valued. We treat them as if they were set from Fortran MPI-1 (i.e., MPI_ATTR_PUT) or Fortran MPI-2 (i.e., MPI_xxx_ATTR_SET). Most attributes are MPI-1 integer-valued, meaning that they are the size of MPI_Fint (INTEGER). But MPI_WIN_SIZE and MPI_WIN_DISP_UNIT are MPI-2 integer-valued, meaning that they are the size of MPI_Aint (INTEGER(KIND=MPI_ADDRESS_KIND)).
.PP
MPI_TAG_UB is set to a fixed upper limit.
.PP
MPI_HOST is set to MPI_PROC_NULL (per MPI-1, see 7.1.1, p192).
.PP
MPI_IO is set to MPI_ANY_SOURCE. We may need to revist this.
.PP
MPI_WTIME_IS_GLOBAL is set to 0 (a conservative answer).
.PP
MPI_APPNUM is set as the result of a GPR subscription.
.PP
MPI_LASTUSEDCODE is set to an initial value and is reset every time MPI_ADD_ERROR_CLASS is invoked. Its copy function is set to MPI_COMM_NULL_COPY_FN, meaning that *only* MPI_COMM_WORLD will have this attribute value. As such, we only have to update MPI_COMM_WORLD when this value changes (i.e., since this is an integer-valued attribute, we have to update this attribute on every communicator -- using NULL_COPY_FN ensures that only MPI_COMM_WORLD has this attribute value set).
.PP
MPI_UNIVERSE_SIZE is set as the result of a GPR subscription.
.PP
MPI_WIN_BASE is an address-valued attribute, and is set directly from MPI_WIN_CREATE. MPI_WIN_SIZE and MPI_WIN_DISP_UNIT are both integer-valued attributes, *BUT* at least the MPI_WIN_SIZE is an MPI_Aint, so in terms of consistency, both should be the same -- hence, we treat them as MPI-2 Fortran integer-valued attributes. All three of these atrributes have NULL_COPY_FN copy functions; it doesn't make sense to copy them to new windows (because they're values specific and unique to each window) -- especially when WIN_CREATE will explicitly set them on new windows anyway.
.PP
These are not supported yet, but are included here for consistency:
.PP
MPI_IMPI_CLIENT_SIZE, MPI_IMPI_CLIENT_COLOR, MPI_IMPI_HOST_SIZE, and MPI_IMPI_HOST_COLOR are integer-valued attributes.
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
